



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>如何使用 HTTP 响应头字段来提高 Web 安全性？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">如何使用 HTTP 响应头字段来提高 Web 安全性？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 11:57:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>在 Web 服务器做出响应时，为了提高安全性，在 HTTP 响应头中可以使用的各种响应头字段。</strong></p>
<h2>X-Frame-Options</h2>
<p>该响应头中用于控制是否在浏览器中显示 frame 或 iframe 中指定的页面，主要用来防止 Clickjacking （点击劫持）攻击。</p>
<pre class="prettyprint linenums"><code>X-Frame-Options: SAMEORIGIN<br />
</code></pre>
<ul><li>DENY 禁止显示 frame 内的页面（即使是同一网站内的页面）</li>
<li>SAMEORIGIN</li>
<li>允许在 frame 内显示来自同一网站的页面，禁止显示来自其他网站的页面</li>
<li>ALLOW-FROM origin_uri 允许在 frame 内显示来自指定 uri 的页面（当允许显示来自于指定网站的页面时使用）</li></ul>
<h2>X-Content-Type-Options</h2>
<p>如果从 script 或 stylesheet 读入的文件的 MIME 类型与指定 MIME 类型不匹配，不允许读取该文件。用于防止 <a href="http://news.oneapm.com/tag/xss/" rel="external nofollow noreferrer">XSS</a> 等跨站脚本攻击。</p>
<pre class="prettyprint linenums"><code>X-Frame-Options: nosniff<br />
</code></pre>
<h2>X-XSS-Protection</h2>
<p>用于启用浏览器的 XSS 过滤功能，以防止 XSS 跨站脚本攻击。</p>
<pre class="prettyprint linenums"><code>X-XSS-Protection: 1; mode=block<br />
</code></pre>
<ul><li>0 禁用 XSS 过滤功能</li>
<li>1 启用 XSS 过滤功能</li></ul>
<h2>Content-Security-Policy</h2>
<p>用于控制当外部资源不可信赖时不被读取。用于防止 <a href="https://www.oneasp.com/sp/xss/" rel="external nofollow noreferrer">XSS 跨站脚本攻击</a>或数据注入攻击（但是，如果设定不当，则网站中的部分脚本代码有可能失效)。</p>
<p>之前的字段名为 X-Content-Security-Policy</p>
<pre class="prettyprint linenums"><code>Content-Security-Policy: default-src 'self'<br />
</code></pre>
<ul><li>default-src 'self'：允许读取来自于同源（域名+主机+端口号）的所有内容</li>
<li>default-src 'self'</li>
<li>*.example.com：允许读取来自于指定域名及其所有子域名的所有内容</li></ul>
<h2>X-Permitted-Cross-Domain-Policies</h2>
<p>用于指定当不能将&quot;crossdomain.xml&quot;文件（当需要从别的域名中的某个文件中读取 Flash 内容时用于进行必要设置的策略文件）放置在网站根目录等场合时采取的替代策略。</p>
<pre class="prettyprint linenums"><code>X-Permitted-Cross-Domain-Policies: master-only<br />
</code></pre>
<ul><li>master-only 只允许使用主策略文件（/crossdomain.xml）</li></ul>
<h2>Strict-Transport-Security</h2>
<p>用于通知浏览器只能使用 HTTPS 协议访问网站。用于将 HTTP 网站重定向到 HTTPS 网站。</p>
<pre class="prettyprint linenums"><code>Strict-Transport-Security: max-age=31536; includeSubDomains<br />
</code></pre>
<ul><li>max-age 用于修改 STS 的默认有效时间。</li>
<li>includeSubDomains 用于指定所有子域名同样使用该策略。</li></ul>
<h2>Access-Control-Allow-Origin等CORS相关字段</h2>
<p>当使用 XMLHttpRequest 从其他域名中获取资源进行跨域通信时使用。</p>
<pre class="prettyprint linenums"><code>Access-Control-Allow-Origin: http://www.example.com<br />
Access-Control-Allow-Methods: POST, GET, OPTIONS<br />
Access-Control-Allow-Headers: X-TRICORDER<br />
Access-Control-Max-Age: 1728<br />
</code></pre>
<p>上述代码用于设定与&quot;<a href="http://www.example.com" rel="external nofollow noreferrer">http://www.example.com</a>&quot;进行跨域通信处理，允许使用 POST, GET, OPTIONS 方法，在发送的请求头中添加 X-TRICORDER 字段，通信超时时间为1,728,00秒。</p>
<h2>HTTP响应头的设定方法</h2>
<p>在 Apache 服务器中指定响应头时，需要在 httpd.conf 文件中将下述模块设定为有效状态。</p>
<pre class="prettyprint linenums"><code>LoadModule headers_module modules/mod_headers.so<br />
</code></pre>
<p>然后使用下述方法设定 HTTP 响应头。</p>
<pre class="prettyprint linenums"><code>Header set HeaderFieldName &quot;value&quot;<br />
//例如<br />
Header set X-XSS-Protection &quot;1; mode=block”<br />
</code></pre>
<p><strong>本文系 <a href="https://www.oneasp.com/?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E5%A6%82%E4%BD%95%E4%BD%BF%E7%94%A8%20HTTP%20%E5%93%8D%E5%BA%94%E5%A4%B4%E5%AD%97%E6%AE%B5%E6%9D%A5%E6%8F%90%E9%AB%98%20Web%20%E5%AE%89%E5%85%A8%E6%80%A7%EF%BC%9F&amp;utm_campaign=AspRaspArti&amp;from=jswgiadjen" rel="external nofollow noreferrer">OneASP</a> 工程师王开放原创文章。如今，多样化的攻击手段层出不穷，传统安全解决方案越来越难以应对网络安全攻击。<a href="https://www.oneasp.com/?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E5%A6%82%E4%BD%95%E4%BD%BF%E7%94%A8%20HTTP%20%E5%93%8D%E5%BA%94%E5%A4%B4%E5%AD%97%E6%AE%B5%E6%9D%A5%E6%8F%90%E9%AB%98%20Web%20%E5%AE%89%E5%85%A8%E6%80%A7%EF%BC%9F&amp;utm_campaign=AspRaspArti&amp;from=jswgiadjen" rel="external nofollow noreferrer">OneRASP</a> 实时应用自我保护技术,可以为软件产品提供精准的实时保护，使其免受漏洞所累。想阅读更多技术文章，请访问 OneAPM 官方技术博客</strong><br /><br />
<strong>本文转自 <a href="http://news.oneapm.com/" rel="external nofollow noreferrer">OneAPM 官方博客</a></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pwo4z8.html">2&period;Java基础之Runtime对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq15ox09.html">在SOUI中非半透明窗口如何实现圆角窗口？</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k40dj9.html">&lbrack;HDU5903&rsqb;Square Distance&lpar;DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxp3k9.html">Linux内核--网络栈实现分析（一）--网络栈初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8engex8.html">从TP、FP、TN、FN到ROC曲线、miss rate、行人检测评估</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1gpj9.html">C&plus;&plus;的那些事：表达式与语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjn738.html">Android 儿子Activity在启动过程中的流程组件 &amp;amp&semi;amp&semi;&amp;amp&semi;amp&semi; 儿子Activity在一个新的进程组件启动过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljn7o69.html">关于mysql中触发器old和new如何更好的区别我有话要说？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7ke48.html">POI读取excel工具类 返回实体bean集合&lpar;xls&comma;xlsx通用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ko4329.html">视频聊天 Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17yymq.html">server&period;go 源码阅读</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpjzj8.html">Shell-仅保留最近3天的备份文件&colon; find &period; -name &amp;quot&semi;&ast;&period;sql&amp;quot&semi; -mtime &plus;3 -ls -exec rm &lbrace;&rcub; &bsol;&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydn5mq.html">使用korofileheader插件vs code添加文件头注释和函数注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rl0j58.html">建站工具Hexo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvwrzz8.html">Golang中mac地址&plus;时间戳加入rand&period;Seed&lpar;&rpar;产生随机数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e42ykj9.html">root密码重置（Centos 7）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j1pd5q.html">Elasticsearch 学习之不停止服务，完成升级重启维护操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynzov9.html">图片上传前 压缩，base64图片压缩  Exif&period;js处理ios拍照倒置等问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjxwn7q.html">BZOJ3635谈笑风生</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj5mv08.html">View Pi&apos;s Status on WebBrowser</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwdx6yr8.html">Android和Java的轻巧Wire协议缓冲器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm7zw69.html">Linux基础命令（三）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnx0xj8.html">linux下安装apache2&period;4</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vn7n48.html">Magento Block设计分析&lpar;深入分析&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydl16dq.html">socket的NIO操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm2jx69.html">MVC小系列（七）【分部视图中的POST】</a>
			</li>
						<li><a href="https://www.batexi.com/a/96okp6j9.html">Web前端&sol;后端</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvoem1q.html">asp&period;net  WebService异步</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e170wm9.html">javascript中event&period;keycode大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnrl4e8.html">JSON&period;parse 函数应用 （复制备忘）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
